CON

{{SidDOS v. 0.02}}

  _clkmode = xtal1+pll16x
  _clkfreq = 117_964_800
  '_clkfreq = 100_000_000
  '_clkfreq = 80_000_000

  _SD_DO = 0
  _SD_CLK = 1
  _SD_DI = 2
  _SD_CS = 3
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.



  rightPin = 10
  leftPin  = 11

var
byte cmdbuf[81]
byte cmdbuf2[81]
byte cptr
byte buffer2[25]
byte namebuf[125*32]
long pos
byte playrate
byte il

OBJ

  kbm           : "kbm"
  vga           : "vn2030-20120608"
  fat           : "kyefat"
  sid           : "sidcog"

Pub Start | char, mx, my, dmx,dmy, buffer, i, x,y,code


  kbm.start(24,25,26,27)

  waitcnt(clkfreq*3 + cnt)                              'delay for debugging

  vga.start
  sid.start(rightPin, leftPin)


  ifnot( fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1))
    vga.writeln(string("FAT engine start failed"))
  vga.cursoroff


  vga.outtextxy(31,0, string("SidPlay ver. 0.02"))
  repeat i from 5 to 15
    vga.setfontcolor(0,i,0,3,0)

  vga.outtextxy(34,1, string("Scanning..."))
  repeat i from 5 to 15
    vga.setfontcolor(1,i,3,0,0)

'  if kbm.keyboardpresent <> 0
'    vga.writeln(string("Keyboard present"))
'  if kbm.mousepresent <> 0
'    vga.writeln(string("Mouse present"))


  fat.mountPartition(0)     ' mount the sd card
  ifnot(fat.partitionMounted)

    vga.writeln(string("Card Not Mounted "))

  il:=scan-1

'****** main loop
  pos:=0

  repeat i from 0 to 4
    vga.setfontcolor(3,i,3,3,0)
    vga.setbackcolor(3,i,0,2,0)

  repeat

    if char:=kbm.key
      if char==$c3
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos+=1
        if pos>il
          pos:=0
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if char==$c2
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos-=1
        if pos<0
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if char==$c1
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos+=25
        if pos>il
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if char==$c0
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos-=25
        if pos<0
          pos:=0
        if pos>il
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)

      if char==13
        repeat
          code:=playcmd
        until code==-1




{
'***********************************

  vga.write(string("Mounted "))
  vga.write(fat.partitionFilesystemType)
  vga.write(string(" disk "))
  vga.writeln(fat.partitionVolumeLabel)
  vga.write(vga.inttostr(fat.partitionFreeSectorCount("F")))
  vga.writeln(string(" sectors free"))
  vga.writeln(string(" "))
  vga.write(string("C:\>"))

'******************************************************

  bytefill(@cmdbuf,0,81)
  cptr:=0

'***** main loop
  repeat
    if char := kbm.key 'keypressed

      if char==13
        if strcomp(@cmdbuf,string("dir"))
          dircmd
          next
        bytefill(@cmdbuf2,0,81)
        bytemove(@cmdbuf2,@cmdbuf,4)
        if strcomp(@cmdbuf2,string("play"))
          playcmd
          next


        vga.writeln(string(" "))
        vga.write(string("Command not recognized: "))
        vga.writeln(@cmdbuf)
        vga.writeln(string(" "))
        vga.write(string("C:\>"))
        bytefill(@cmdbuf,0,81)
        cptr:=0
        next

'********** Polish special char - delete if you don't need it

      if char>$400
        if char==$441
          char:=14
        if char==$445
          char:=15
        if char==$443
          char:=16
        if char==$44e
          char:=17
        if char==$453
          char:=18
        if char==$458
          char:=19
        if char==$45a
          char:=20
        if char==$44f
          char:=21
        if char==$44c
          char:=22
        if char==$461
          char:=23
        if char==$465
          char:=24
        if char==$463
          char:=25
        if char==$46e
          char:=26
        if char==$473
          char:=27
        if char==$478
          char:=28
        if char==$47a
          char:=29
        if char==$46f
          char:=30
        if char==$46c
          char:=31

'************** End of Polish char section

      if char>13 and char<128
        cmdbuf[cptr]:=char
        cptr+=1
        if cptr==80
          cptr:=79
        vga.write(@char)
        next

      if char==$c8
        if cptr>0
          cptr-=1

          cmdbuf[cptr]:=0
          vga.backspace

        next


pub dircmd |i,buffer,f,c

vga.writeln(string(" "))

i:=0
f:=0

vga.write(string("Volume in drive C is "))
vga.writeln(fat.partitionVolumeLabel)
vga.writeln(string(" "))

fat.listEntries("W")
repeat while(buffer := fat.listEntries("N"))
  vga.writeln(buffer)
  i:=i+1
  f:=f+1
  if (i==25)
    vga.write(string("--more--"))
    repeat until c:=kbm.key
    if c==$263
      quit
    vga.setcursorx(0)
    vga.write(string("        "))
    vga.setcursorx(0)
    i:=0
bytefill(@cmdbuf,0,81)
cptr:=0
vga.writeln(string(" "))
vga.write(vga.inttostr(f))
vga.write(string(" files, "))
vga.write(vga.inttostr(fat.partitionFreeSectorCount("F")))
vga.writeln(string(" sectors free"))
vga.writeln(string(" "))
vga.write(string("C:\>"))

}
pub playcmd |c, ch, x,y,i,qqq,qq

'bytemove(@cmdbuf,@cmdbuf+5,77)
\fat.openfile(@namebuf+32*pos,"r")

playrate:=namebuf[32*pos+14]

'vga.writeln(string(" "))
c:=fat.readdata(@buffer2,25)
if c<>25
  vga.write(string("File not found - "))
  vga.write(@cmdbuf)
  bytefill(@cmdbuf,0,81)
  bytefill(@cmdbuf2,0,81)
  cptr:=0
  vga.writeln(string(" "))
  vga.writeln(string(" "))
  vga.write(string("C:\>"))
  return
vga.outtextxy(20,29,string("Playing file "))
vga.outtextxy(33,29,string("                "))
vga.outtextxy(33,29,@namebuf+32*pos+15)
  repeat i from 0 to 12
    vga.setfontcolor(29,i,3,1,0)
'vga.write(@cmdbuf)
'vga.write(string(" - press Ctrl-C to quit"))
qqq:=0
repeat
  waitcnt(cnt + (clkfreq/playRate))
  c:=fat.readdata(@buffer2,25)
  sid.updateRegisters(@buffer2)
  qq:=qqq<<24+qqq<<8+$00040004
'  vga.poke2(489,qq)
'  vga.poke2(491,qq)
  qqq+=1
  qqq&=255
  ch:=kbm.key


'*********************


      if ch==$c3
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos+=1
        if pos>il
          pos:=0
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if ch==$c2
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos-=1
        if pos<0
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if ch==$c1
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos+=25
        if pos>il
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if ch==$c0
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos-=25
        if pos<0
          pos:=0
        if pos>il
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


'*******************


until (c<>25) or (ch==$263) or (ch==13)
fat.closefile
bytefill(@buffer2,0,25)
sid.updateRegisters(@buffer2)

if ch==13
  return pos
else
  return -1



pub  scan|i,buffer,g,c,freq,l,x,y


i:=0


fat.listEntries("W")
repeat while(buffer := fat.listEntries("N"))
  l:=11
  repeat while byte[buffer+l]==32
    byte[buffer+l]:=0
    l-=1
  l:=strsize(buffer)
  if strcomp(buffer+l-3,string("DMP"))

    bytemove(@namebuf+(32*i),buffer,13)
    \fat.openfile(buffer,"r")
    c:=fat.readdata(@buffer2,25)
    if (buffer2[0]=="S") and (buffer2[1]=="D") and (buffer2[2]=="M") and (buffer2[3]=="P")
      freq:=buffer2[4]

      namebuf[32*i+14]:=freq
      bytemove(@namebuf+32*i+15,@buffer2+8,16)


    else
      byte[buffer+l-4]:=0
      bytemove(@namebuf+32*i+15,buffer,l)
      namebuf[32*i+14]:=50

    i:=i+1

    if i>99
      quit





repeat g from 0 to i-1
  x:=(g/25)*20+2
  y:=(g//25)+3
  vga.outtextxy(x,y,@namebuf+32*g+15)

vga.outtextxy(34,1, string("           "))

result:=i


